Package org.eclipse.cdt.core.dom.ast.cpp

# Interface ICPPASTCompositeTypeSpecifier.ICPPASTBaseSpecifier

All Superinterfaces:
  `IASTNameOwner`, `IASTNode`, `ICPPASTPackExpandable`

Enclosing interface:
  ICPPASTCompositeTypeSpecifier

public static interface ICPPASTCompositeTypeSpecifier.ICPPASTBaseSpecifier extends IASTNode, IASTNameOwner, ICPPASTPackExpandable
Base specifiers are where a class expresses from whom it inherits.

Restriction:
  This interface is not intended to be implemented by clients.

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`IASTNode.CopyStyle`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final ICPPASTCompositeTypeSpecifier.ICPPASTBaseSpecifier[]`
`EMPTY_BASESPECIFIER_ARRAY`
`static final ASTNodeProperty`
`NAME`
Deprecated.
Use `NAME_SPECIFIER` instead.
`static final ASTNodeProperty`
`NAME_SPECIFIER`
Relation between base specifier and its name specifier.
`static final int`
`v_private`
`static final int`
`v_protected`
`static final int`
`v_public`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNameOwner

`r_declaration, r_definition, r_reference, r_unclear`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`EMPTY_NODE_ARRAY`

## Method Summary

Modifier and Type
Method
Description
`ICPPASTCompositeTypeSpecifier.ICPPASTBaseSpecifier`
`copy()`
Returns a mutable copy of the tree rooted at this node.
`ICPPASTCompositeTypeSpecifier.ICPPASTBaseSpecifier`
`copy(IASTNode.CopyStyle style)`
Returns a mutable copy of the tree rooted at this node.
`IASTName`
`getName()`
Deprecated.
Use getNameSpecifier() instead.
`ICPPASTNameSpecifier`
`getNameSpecifier()`
Returns the name specifier inside this base specifier.
`int`
`getVisibility()`
Returns the accessibility for the base.
`boolean`
`isVirtual()`
Returns whether this specifies a virtual base.
`void`
`setName(IASTName name)`
Deprecated.
Use setNameSpecifier() instead.
`void`
`setNameSpecifier(ICPPASTNameSpecifier nameSpecifier)`
Sets the name specifier for this base specifier.
`void`
`setVirtual(boolean value)`
Sets whether this specifier is for a virtual base.
`void`
`setVisibility(int visibility)`
Sets the visibility of this specifier, not allowed on frozen AST.

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNameOwner

`getRoleForName`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`accept, contains, getChildren, getContainingFilename, getFileLocation, getLeadingSyntax, getNodeLocations, getOriginalNode, getParent, getPropertyInParent, getRawSignature, getSyntax, getTrailingSyntax, getTranslationUnit, isActive, isFrozen, isPartOfTranslationUnitFile, setParent, setPropertyInParent`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.cpp.ICPPASTPackExpandable

`isPackExpansion, setIsPackExpansion`

## Field Details

### EMPTY_BASESPECIFIER_ARRAY

static final ICPPASTCompositeTypeSpecifier.ICPPASTBaseSpecifier[] EMPTY_BASESPECIFIER_ARRAY

### NAME_SPECIFIER

static final ASTNodeProperty NAME_SPECIFIER
Relation between base specifier and its name specifier.

Since:
  5.8

### NAME

@Deprecated static final ASTNodeProperty NAME
Deprecated.
Use `NAME_SPECIFIER` instead.

Restriction:
  This field is not intended to be referenced by clients.

### v_public

static final int v_public

See Also:
  - Constant Field Values

### v_protected

static final int v_protected

See Also:
  - Constant Field Values

### v_private

static final int v_private

See Also:
  - Constant Field Values

## Method Details

### isVirtual

boolean isVirtual()
Returns whether this specifies a virtual base.

### getVisibility

int getVisibility()
Returns the accessibility for the base.

### getName

@Deprecated IASTName getName()
Deprecated.
Use getNameSpecifier() instead.

Restriction:
  This method is not intended to be referenced by clients.

### getNameSpecifier

ICPPASTNameSpecifier getNameSpecifier()
Returns the name specifier inside this base specifier.

Since:
  5.8

### copy

ICPPASTCompositeTypeSpecifier.ICPPASTBaseSpecifier copy()
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Calling this method is equivalent to `copy(CopyStyle.withoutLocations)`.

Specified by:
  `copy` in interface `IASTNode`
Since:
  5.1

### copy

ICPPASTCompositeTypeSpecifier.ICPPASTBaseSpecifier copy(IASTNode.CopyStyle style)
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Specified by:
  `copy` in interface `IASTNode`
Parameters:
  `style` - `IASTNode.CopyStyle` create a copy with or without locations. Please see `IASTNode.CopyStyle` for restrictions on copies with Locations.
Since:
  5.3

### setName

@Deprecated void setName(IASTName name)
Deprecated.
Use setNameSpecifier() instead.

Restriction:
  This method is not intended to be referenced by clients.

### setNameSpecifier

void setNameSpecifier(ICPPASTNameSpecifier nameSpecifier)
Sets the name specifier for this base specifier. Not allowed on frozen AST.

Since:
  5.8

### setVirtual

void setVirtual(boolean value)
Sets whether this specifier is for a virtual base. Not allowed on frozen AST.

### setVisibility

void setVisibility(int visibility)
Sets the visibility of this specifier, not allowed on frozen AST.